(*
      TOP - DOWN DESIGN, metodom postupnog profinjavanja

Zadatak: Nacrtaj ahovnicu koristei samo WRITE i WRITELN procedure
	 (bez GOTOXY ili grafikih procedura), koristei neki znak
         za crtanje svijetlog polja, a neki drugi za tamno polje.
         Uitaj irinu i visinu pravokutnika, broj pravokutnika u
         redu i u stupcu, te poetno polje.

                          Crta Crta Crta           Crta
   Ploa    Red    Redak  XXXXX.....XXXXX.....XXXXX.....
                   Redak  XXXXX.....XXXXX.....XXXXX.....
                   Redak  XXXXX.....XXXXX.....XXXXX.....
            Red    Redak  .....XXXXX.....XXXXX.....XXXXX
                   Redak  .....XXXXX.....XXXXX.....XXXXX
                          .....XXXXX.....XXXXX.....XXXXX
            Red           XXXXX.....XXXXX.....XXXXX.....
                          XXXXX.....XXXXX.....XXXXX.....
                          XXXXX.....XXXXX.....XXXXX.....
            Red           .....XXXXX.....XXXXX.....XXXXX
                          .....XXXXX.....XXXXX.....XXXXX
                   Redak  .....XXXXX.....XXXXX.....XXXXX

{******* Glavni program ***************************}
BEGIN
  Ponavljaj
     uitaj irinu, visinu, br_stupaca, br_redova, boju poetnog polja
     ako je poetno polje svijetlo
                               onda ploca (pomi svijetlom bojom)
                               inae ploca(pomi tamnom bojom);
  dok korisnik ne kae dosta
END.

PROCEDURE ploa (poetna boja) *********************
BEGIN
     br_redova puta
         ispii red (boja);
         boja := NOT boja;
END;

PROCEDURE red (poetna boja); **********************
BEGIN
     visina puta ispii redak (poevi s bojom)
END;

PROCEDURE redak (poetna boja) *********************
BEGIN
     br_stupaca puta
         ispii crtu (odgovarajue boje);
         boja := NOT boja;
     prei u novi red
END;

PROCEDURE crta ( koje boje ) ************************
BEGIN
     ako je boja svijetla onda znak := bijelo
                          inae znak := crno;
     sirina puta ispii znak
END;
*)
PROGRAM karirani;  (* PRIMJER ZA PROCEDURE - iscrtavanje ahovnice *)
CONST   crno='.'; bijelo='#';
VAR     jos: CHAR;                      (* globalne varijable *)
        sirina, visina, br_redova, br_stupaca:   INTEGER;
        brojac: Integer;
PROCEDURE crta(boja: BOOLEAN);
VAR i: INTEGER;
    znak: CHAR;
BEGIN
     IF boja THEN znak := bijelo
             ELSE znak := crno;
     FOR i:=1 TO sirina DO BEGIN WRITE(znak); Inc(brojac) END;
END;
PROCEDURE redak(boja: BOOLEAN);
VAR i: INTEGER;
BEGIN
     FOR i:=1 TO br_stupaca DO BEGIN
         crta(boja);
         boja := NOT boja;
     END;
     WRITELN;
END;
PROCEDURE red(boja: BOOLEAN);
VAR i: INTEGER;
BEGIN
     FOR i:=1 TO visina DO redak(boja)
END;
PROCEDURE ploca(boja: BOOLEAN);
VAR i: INTEGER;
BEGIN
     FOR i:=1 TO br_redova DO BEGIN
         red(boja);
         boja := NOT boja;
     END;
END;
(******* Glavni program *******)
BEGIN
  REPEAT
     WRITELN; WRITE('irina osnovnog pravokutnika? '); READLN(sirina);
     WRITE('Visina osnovnog pravokutnika? '); READLN(visina);
     WRITE('Koliko stupaca u redu? '); READLN(br_stupaca);
     WRITE('Koliko redaka u stupcu? '); READLN(br_redova);
     WRITE('Da li je poetno polje svijetlo? '); READLN(jos);
     IF (jos='D') OR (jos='d') THEN ploca(TRUE)
                               ELSE ploca(FALSE);
     Writeln('Broj znakova: ',brojac);
     WRITE('Jo? '); READLN(jos);
  UNTIL (jos='N') OR (jos='n')
END.

1) U svakoj proceduri deklarirana je varijabla I. to se deava s
   varijablom I u pozivajuoj proceduri kad se promijeni u pozvanoj
   proceduri?
   to e se dogoditi ako deklaraciju varijable I premjestimo u glavni
   program, a izostavimo u procedurama?
2) to e se dogoditi ako u jednu od procedura stavi u deklaraciju
   formalnog parametra VAR ispred naziva parametra? Odgovori za svaku
   proceduru posebno, a odgovor provjeri za raunalom! Obrazloi!
3) to e se dogoditi ako umjesto parametra BOJA koristi globalnu varijablu
   BOJA? Obrazloi odgovor i provjeri za raunalom!
4) Da li bi se neka od procedura mogla izostaviti, tj. napisati kao dio
   pozivajue? Bi li program bio jasniji da se uvede jo neka procedura?
5) Program se moe prepraviti da radi bez procedura. Pokuaj, pa uoi
   prednosti i nedostatke svakog postupka!
